/*
 * This file is a part of the SteamWar software.
 *
 * Copyright (C) 2022  SteamWar.de-Serverteam
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.features.worldedit.mask.above;

import com.sk89q.worldedit.function.mask.Mask;
import com.sk89q.worldedit.math.BlockVector3;

public class AboveMask implements Mask {

    private Mask mask;
    private int distance;

    public AboveMask(Mask mask, int distance) {
        this.mask = mask;
        this.distance = distance;
    }

    @Override
    public boolean test(BlockVector3 vector) {
        for (int i = 1; i <= distance; i++) {
            if (mask.test(vector.subtract(0, i, 0))) {
                return true;
            }
        }
        return false;
    }

    @Override
    public Mask copy() {
        return new AboveMask(mask, distance);
    }
}
